//---------------------------------------------------------------------------

#include <vcl.h>
#include <atl\atlbase.h>
#include "VCapStrings.hpp"
#pragma hdrstop

// if u don't need to save graph u can delete #include <qedit.h>
#include <qedit.h>
#include "MainForm.h"
#include "GraphConfig.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VCap"
#pragma resource "*.dfm"
TFMain *FMain;
//---------------------------------------------------------------------------
__fastcall TFMain::TFMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFMain::FormShow(TObject *Sender)
{
  if (!cap->Init()) {
    ShowMessage("Can't init capture!");
    Application->Terminate();
  };
}
//---------------------------------------------------------------------------
void __fastcall TFMain::capCaptureProgress(TObject *Sender)
{
  StatusBar->SimpleText = "Frames Captured "+IntToStr(cap->NotDropped)+
                          ". Frames Dropped "+IntToStr(cap->FramesDropped)+
                          ". Capture time "+IntToStr(cap->CapTime / 1000)+'.'+
                          IntToStr((cap->CapTime / 10) % 100);
  btStart->Enabled = !cap->Capturing;
  btStop->Enabled = !btStart->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::btStartClick(TObject *Sender)
{
  cap->StartCapture(true);
  capCaptureProgress(this);
}
//---------------------------------------------------------------------------
void __fastcall TFMain::btStopClick(TObject *Sender)
{
  cap->StopCapture();
  capCaptureProgress(this);
}
//---------------------------------------------------------------------------
void __fastcall TFMain::btCaptureFrameClick(TObject *Sender)
{
  if (!cap->CaptureFrame()) ShowMessage("Can't capture frame!");
}
//---------------------------------------------------------------------------
void __fastcall TFMain::FormClose(TObject *Sender, TCloseAction &Action)
{
  cap->StopPreview();
  cap->StopCapture();
}
//---------------------------------------------------------------------------
void __fastcall TFMain::capChangeDevice(TObject *Sender)
{
  TVCapMode cvcapMode = cap->VCapMode;
  TACapMode cacapMode = cap->ACapMode;

  cbVModes->Items->Clear();
  int capCount = cap->VCapModeCount;
  for (int i = 0; i<capCount; i++) {
    TVCapMode vcapMode = cap->VCapModes[i];
    cbVModes->Items->Add(GetModeString(vcapMode));
    if (IsEqualModes(cvcapMode, vcapMode)) cbVModes->ItemIndex = i;
  };

  cbAModes->Items->Clear();
  capCount = cap->ACapModeCount;
  for (int i = 0; i<capCount; i++) {
    TACapMode acapMode = cap->ACapModes[i];
    cbAModes->Items->Add(GetModeString(acapMode));
    if (IsEqualModes(cacapMode, acapMode)) cbAModes->ItemIndex = i;
  };

  lbDialogs->Items->Clear();
  for (TCaptureDialog d = cdVFORMAT; d <= cdACOMPRESSION; d+=1) 
    if (cap->Dialogs.Contains(d))
      lbDialogs->Items->AddObject(DialogTitles[d], (TObject*)d);

}
//---------------------------------------------------------------------------
void __fastcall TFMain::cbVModesChange(TObject *Sender)
{
  cap->SetVCapMode(cbVModes->ItemIndex);
  cap->StartPreview();
}
//---------------------------------------------------------------------------
void __fastcall TFMain::cbAModesChange(TObject *Sender)
{
  cap->SetACapMode(cbAModes->ItemIndex);
  cap->StartPreview();
}
//---------------------------------------------------------------------------
void __fastcall TFMain::lbDialogsClick(TObject *Sender)
{
  if (lbDialogs->Items->Count>0 && lbDialogs->ItemIndex>=0)
    cap->ShowDialog((TCaptureDialog)lbDialogs->Items->Objects[lbDialogs->ItemIndex]);
}
//---------------------------------------------------------------------------
void __fastcall TFMain::capStartPreview(TObject *Sender)
{
// refresh cur modes
  cbVModes->ItemIndex = cap->VCapModeIdx;
  cbAModes->ItemIndex = cap->VCapModeIdx;
  framecount = 0;
  lbFrames->Caption = "";
}
//---------------------------------------------------------------------------

void __fastcall TFMain::TimerTimer(TObject *Sender)
{
  // make a delay to show form (let form get a handle)
  Timer->Enabled = false;
  cap->RestoreGraph(config);
}
//---------------------------------------------------------------------------
void __fastcall TFMain::Button1Click(TObject *Sender)
{
  if (cap->CaptureGraph==NULL) return;
  CComPtr<IXml2Dex> x;
  if (x.CoCreateInstance(__uuidof(Xml2Dex))==S_OK)
    x->WriteGrfFile(cap->CaptureGraph, L"graph.grf");
}
//---------------------------------------------------------------------------
void __fastcall TFMain::FormCreate(TObject *Sender)
{
  config = new TGraphConfig();
}
//---------------------------------------------------------------------------
void __fastcall TFMain::FormDestroy(TObject *Sender)
{
  delete config;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::Button2Click(TObject *Sender)
{
  cap->SaveGraph(config);
  if (EditGraphConfig(config)) cap->RestoreGraph(config);
}
//---------------------------------------------------------------------------
void __fastcall TFMain::capBitmapGrabbed(TCapturedBitmap *CapturedImage)
{
  CapturedImage->SaveToFile(feBitmap->Text);
  Image->Picture->Assign(CapturedImage);
}
//---------------------------------------------------------------------------
void __fastcall TFMain::capFrameRendered(TObject *Sender)
{
  framecount = framecount + 1;
  lbFrames->Caption = "Frames passed: "+IntToStr(framecount);
}
//---------------------------------------------------------------------------
void __fastcall TFMain::capStopPreview(TObject *Sender)
{
  framecount = 0;
  lbFrames->Caption = "";
}
//---------------------------------------------------------------------------

